from math import sqrt
N = int(input())
cells = []
for i in range(N):
    X, Y = map(int, input().split())
    cells.append([X, Y])

K = int(input())
data_dict = {}
for i in range(K):
    inp = list(map(int, input().split()))
    
    data_dict[inp[0]] = [[inp[j], inp[j+1]] for j in range(1,len(inp),2)]

db = []
for key in sorted(data_dict.keys()):
    db.append(data_dict[key])

points = []
for i in range(K):
    data = db[i]
    y1b = (100-data[0][1])/100*1000
    y2b = (100-data[1][1])/100*1000
    y3b = (100-data[2][1])/100*1000
    i1 = data[0][0]
    i2 = data[1][0]
    i3 = data[2][0]
    x1 = cells[i1-1][0]
    x2 = cells[i2-1][0]
    x3 = cells[i3-1][0]
    y1 = cells[i1-1][1]
    y2 = cells[i2-1][1]
    y3 = cells[i3-1][1]

    if x2-x1 == 0:
        a = (x3*x3-x2*x2) + (y3*y3-y2*y2) + y2b*y2b - y3b*y3b
        b = 2*(x3-x2)
        z = 2*(y3-y1)-4*(y3-y2)*(x3-x1)/b
    else:
        a = (x2*x2-x1*x1) + (y2*y2-y1*y1) + y1b*y1b - y2b*y2b
        b = 2*(x2-x1)
        z = 2*(y3-y1)-4*(y2-y1)*(x3-x1)/b
        
    
    c = -(x3-x1)*2*a/b+ y3*y3 - y1*y1 + x3*x3 -x1*x1 + y1b*y1b -y3b*y3b

    y = c/z

    if x2-x1 == 0:
        x = (a-2*y*(y3-y2))/b
    else:
        x = (a-2*y*(y2-y1))/b
    
    points.append([x, y])

answer = 0
for i in range(len(points)-1):
    x1 = points[i][0]
    y1 = points[i][1]
    x2 = points[i+1][0]
    y2 = points[i+1][1]
    answer += sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))

print(int(round(answer, -2)))
        
