def get_left(numbers):
    k = sum(numbers)
    prev = [-1] * (k // 2 + 1)
    prev[0] = 0
    for val in numbers:
        for i in range(k // 2, val - 1, -1):
            if prev[i] == -1 and prev[i - val] != -1:
                prev[i] = val

    # print(prev)
    curr = k // 2
    # print(curr)
    res = []
    backup = prev.copy()
    try:
        while curr > 0:
            res.append(prev[curr])
            curr -= prev[curr]
    except:
        res = []
        for i in backup[1:]:
            if i > -1:
                res.append(i)
    return res


def divide_by_sums(numbers):
    left = get_left(numbers)
    right = list(numbers)
    for item in left:  # O(n**2)
        right.remove(item)
    return left, right


def print_str(mas):
    mas.sort()
    print(' '.join(list(map(str, mas))))


N = int(input())  # useless
nums = list(map(int, input().split(' ')))

first, second = divide_by_sums(nums)

if sum(first) < sum(second):
    print_str(first)
elif sum(first) > sum(second):
    print_str(second)
elif len(first) < len(second):
    print_str(first)
else:
    print_str(second)
